module saveval_alloc

! 変数の定義
! 変数名の命名規則
! 実数 -> r, 純虚数 -> i, 複素数 -> c
! 平均場 -> b, 擾乱場 -> p
! 時間発展 -> old, new
!-- Allocate working variables in saveval_define

contains

subroutine saveval_allocate()

  use savegloval_define
  use saveval_define

  implicit none

  integer :: err

  allocate(zi(nxi,nyi),stat=err)
  allocate(zor(nx,ny),stat=err)
!  allocate(ur(nx,ny),stat=err)
!  allocate(vr(nx,ny),stat=err)
!  allocate(psior(nx,ny),stat=err)
  allocate(psiko(kxnt,kynt),stat=err)
  allocate(zko(kxnt,kynt),stat=err)
  allocate(psikn(kxnt,kynt),stat=err)
  allocate(pk(kxnt,kynt),stat=err)
  allocate(uko_sbl(kxnt,kynt),stat=err)
  allocate(vko_sbl(kxnt,kynt),stat=err)
  allocate(ukn_sbl(kxnt,kynt),stat=err)
  allocate(vkn_sbl(kxnt,kynt),stat=err)
  allocate(nbm_opt(kxnt,kynt),stat=err)
  allocate(sbl_optu(kxnt,kynt),stat=err)
  allocate(sbl_optv(kxnt,kynt),stat=err)
  allocate(tmpr(nx,ny),stat=err)
  allocate(tmpi(nx,ny),stat=err)

  allocate(u_nbm_isp(jynt,jxnt),stat=err)
  allocate(v_nbm_isp(jynt,jxnt),stat=err)
!  allocate(zor_isp(ny,nx),stat=err)
!  allocate(psior_isp(ny,nx),stat=err)
!  allocate(ur_isp(ny,nx),stat=err)
!  allocate(vr_isp(ny,nx),stat=err)
!  allocate(zko_isp(-hynt:hynt,-hxnt:hxnt),stat=err)
!  allocate(psiko_isp(-hynt:hynt,-hxnt:hxnt),stat=err)
!  allocate(uk_isp(-hynt:hynt,-hxnt:hxnt),stat=err)
!  allocate(vk_isp(-hynt:hynt,-hxnt:hxnt),stat=err)
!  allocate(tmp_work(ny,nx),stat=err)

  if(err/=0)then
     write(*,*) "*** ERROR (saveval_allocate) *** : cannot allocate."
     stop
  end if

end subroutine saveval_allocate

end module saveval_alloc
